% compiles mex files for lightspeed library.
% thanks to Kevin Murphy for suggesting this.

fprintf('Compiling lightspeed mex files...\n');
fprintf('Change directory to lightspeed for this to work.\n');

mex solve_triu.c dtrsm.c
mex solve_tril.c dtrsm.c
mex int_hist.c
mex -c mexutil.c
mex -c util.c

v = sscanf(version,'%d.%d.%s');
if exist('util.obj','file')
  % Windows
  mex digamma.c util.obj
  mex gammaln.c util.obj
  mex randbinom.c util.obj
  mex randgamma.c util.obj
  mex repmat.c mexutil.obj
  mex sample_hist.c util.obj
  mex trigamma.c util.obj
  % standalone programs
  if v(2) >= 5
    % -V5 is required only for Matlab 6.5
    mex -f lccengmatopts.bat matfile.c -V5
  else
    mex -f lccengmatopts.bat matfile.c
  end
  mex -f lccengmatopts.bat test_flops.c
else
  % UNIX
  mex digamma.c util.o -lm
  mex gammaln.c util.o -lm
  mex randbinom.c util.o -lm
  mex randgamma.c util.o -lm
  mex repmat.c mexutil.o
  mex sample_hist.c util.o -lm
  mex trigamma.c util.o -lm
  % standalone programs
  if v(2) >= 5
    % -V5 is required only for Matlab 6.5
    mex -f matopts.sh matfile.c -V5
  else
    mex -f matopts.sh matfile.c
  end  
  mex -f matopts.sh test_flops.c
  % if matlab complains about matopts.sh, your installation of matlab is faulty
end

fprintf('Done.\n');
