function x = ndgridmat(varargin)
% NDGRIDMAT(x1,x2,...)
% Like ndgrid but returns one matrix containing all grid points as rows.
% First dimension varies fastest.

d = length(varargin);
if d == 1
  x = varargin{1}(:);
  return;
end

len = zeros(1,d);
for i = 1:d
  len(i) = length(varargin{i});
end
n = prod(len);
x = zeros(n,d);
k = 1;
for i = 1:d
  xi = varargin{i}(:);
  % might use reparray here
  x(:,i) = repmat(kron(xi, ones(k,1)), n/k/len(i), 1);
  k = k * len(i);
end
